diff --git a/sys/dev/disk/dm/crypt/dm_target_crypt.c b/sys/dev/disk/dm/crypt/dm_target_crypt.c
index 769d40e4f8..d63a8ab2c1 100644
--- a/sys/dev/disk/dm/crypt/dm_target_crypt.c
+++ b/sys/dev/disk/dm/crypt/dm_target_crypt.c
@@ -844,23 +847,17 @@ dm_target_crypt_destroy(dm_table_entry_t *table_en)
  *			STRATEGY SUPPORT FUNCTIONS			*
  ************************************************************************
  *
- * READ PATH:	doio -> bio_read_done -> crypto_work -> crypto_cb_read_done
- * WRITE PATH:	crypto_work -> crypto_cb_write_done -> doio -> bio_write_done
+ * READ PATH:	doio -> bio_read_done -> bio_read_decrypt
+ * WRITE PATH:	bio_write_encrypt -> doio -> bio_write_done
  */
 
-/*
- * Wrapper around crypto_dispatch() to match dispatch_t type
+/**
+ * Use of bio_caller_infoX:
+ *
+ * bio_caller_info1: priv
+ * bio_caller_info2: orig b_data pointer (WRITE PATH only)
+ * bio_caller_info3: data_buf (WRITE PATH only)
  */
-static void
-dmtc_crypto_dispatch(void *arg)
-{
-	struct cryptop *crp;
-
-	crp = (struct cryptop *)arg;
-	KKASSERT(crp != NULL);
-	KTR_LOG(dmcrypt_crypto_dispatch, crp);
-	crypto_dispatch(crp);
-}
 
 /*
  * Start IO operation, called from dmstrategy routine.
@@ -874,11 +871,14 @@ dm_target_crypt_strategy(dm_table_entry_t *table_en, struct buf *bp)
 	priv = table_en->target_config;
 
 	/* Get rid of stuff we can't really handle */
-	if ((bp->b_cmd == BUF_CMD_READ) || (bp->b_cmd == BUF_CMD_WRITE)) {
-		if (((bp->b_bcount % DEV_BSIZE) != 0) || (bp->b_bcount == 0)) {
-			kprintf("dm_target_crypt_strategy: can't really "
-				"handle bp->b_bcount = %d\n",
-				bp->b_bcount);
+	if ((bp->b_cmd == BUF_CMD_READ) ||
+	    (bp->b_cmd == BUF_CMD_WRITE)) {
+		if (((bp->b_bcount % DEV_BSIZE) != 0) ||
+		    (bp->b_bcount == 0)) {
+			kprintf(
+			    "dm_target_crypt_strategy: can't really "
+			    "handle bp->b_bcount = %d\n",
+			    bp->b_bcount);
 			bp->b_error = EINVAL;
 			bp->b_flags |= B_ERROR | B_INVAL;
 			biodone(&bp->b_bio1);
@@ -886,13 +886,11 @@ dm_target_crypt_strategy(dm_table_entry_t *table_en, struct buf *bp)
 		}
 	}
 
-	KTR_LOG(dmcrypt_crypt_strategy, bp->b_cmd, bp);
-
 	switch (bp->b_cmd) {
 	case BUF_CMD_READ:
 		bio = push_bio(&bp->b_bio1);
 		bio->bio_offset = bp->b_bio1.bio_offset +
-				  priv->block_offset * DEV_BSIZE;
+		    priv->block_offset * DEV_BSIZE;
 		bio->bio_caller_info1.ptr = priv;
 		bio->bio_done = dmtc_bio_read_done;
 		vn_strategy(priv->pdev->pdev_vnode, bio);
@@ -900,9 +898,9 @@ dm_target_crypt_strategy(dm_table_entry_t *table_en, struct buf *bp)
 	case BUF_CMD_WRITE:
 		bio = push_bio(&bp->b_bio1);
 		bio->bio_offset = bp->b_bio1.bio_offset +
-				  priv->block_offset * DEV_BSIZE;
+		    priv->block_offset * DEV_BSIZE;
 		bio->bio_caller_info1.ptr = priv;
-		dmtc_crypto_write_start(priv, bio);
+		dmtc_bio_write_encrypt(priv, bio);
 		break;
 	default:
 		vn_strategy(priv->pdev->pdev_vnode, &bp->b_bio1);
@@ -911,9 +909,26 @@ dm_target_crypt_strategy(dm_table_entry_t *table_en, struct buf *bp)
 	return 0;
 }
 
+__inline static int
+select_read_workqueue_index(dm_target_crypt_config_t *priv)
+{
+	return atomic_fetchadd_int(&priv->crypto_read_workqueue_next_rr,
+		   1) %
+	    ncpus;
+}
+
+__inline static int
+select_write_workqueue_index(dm_target_crypt_config_t *priv)
+{
+	return atomic_fetchadd_int(
+		   &priv->crypto_write_workqueue_next_rr, 1) %
+	    ncpus;
+}
+
 /*
- * STRATEGY READ PATH PART 1/3 (after read BIO completes)
+ * STRATEGY READ PATH (after read BIO completes)
  */
+
 static void
 dmtc_bio_read_done(struct bio *bio)
 {
@@ -921,384 +936,231 @@ dmtc_bio_read_done(struct bio *bio)
 
 	dm_target_crypt_config_t *priv;
 
-	KTR_LOG(dmcrypt_bio_read_done, bio->bio_buf);
-
 	/*
 	 * If a read error occurs we shortcut the operation, otherwise
-	 * go on to stage 2.
+	 * go on to stage 2 (decrypt).
 	 */
 	if (bio->bio_buf->b_flags & B_ERROR) {
 		obio = pop_bio(bio);
 		biodone(obio);
 	} else {
 		priv = bio->bio_caller_info1.ptr;
-		dmtc_crypto_read_start(priv, bio);
+		dmtc_bio_read_decrypt(priv, bio);
 	}
 }
 
-/*
- * STRATEGY READ PATH PART 2/3
- */
+__inline static void
+dmtc_bio_read_decrypt_job_do(dm_target_crypt_config_t *priv,
+    struct bio *bio, struct worker_context *ctx);
+
 static void
-dmtc_crypto_read_retry(void *arg1, void *arg2)
+dmtc_bio_read_decrypt_job(void *arg1, void *arg2, void *ctx)
 {
-	dm_target_crypt_config_t *priv = arg1;
-	struct bio *bio = arg2;
-
-	dmtc_crypto_read_start(priv, bio);
+	dmtc_bio_read_decrypt_job_do(arg1, arg2, ctx);
 }
 
-static void
-dmtc_crypto_read_start(dm_target_crypt_config_t *priv, struct bio *bio)
+__inline static void
+dmtc_bio_read_decrypt_job_do(dm_target_crypt_config_t *priv,
+    struct bio *bio, struct worker_context *ctx)
 {
-	struct dmtc_helper *dmtc;
-	struct cryptodesc *crd;
-	struct cryptop *crp;
-	int i, bytes, sectors, sz;
-	off_t isector;
-	u_char *ptr, *space;
+	uint8_t *data_buf = ctx->data_buf;
+
+	KKASSERT(ctx->data_buf_busy == false);
 
 	/*
 	 * Note: b_resid no good after read I/O, it will be 0, use
 	 *	 b_bcount.
 	 */
-	bytes = bio->bio_buf->b_bcount;
-	isector = bio->bio_offset / DEV_BSIZE;	/* ivgen salt base? */
-	sectors = bytes / DEV_BSIZE;		/* Number of sectors */
-	sz = sectors * (sizeof(*crp) + sizeof(*crd));
+	int bytes = bio->bio_buf->b_bcount;
 
 	/*
+	 * Unconditionally copy in data. Never decrypt in place!
+	 *
 	 * For reads with bogus page we can't decrypt in place as stuff
 	 * can get ripped out from under us.
-	 *
-	 * XXX actually it looks like we can, and in any case the initial
-	 * read already completed and threw crypted data into the buffer
-	 * cache buffer.  Disable for now.
 	 */
-	space = mpipe_alloc_callback(&priv->read_mpipe,
-				     dmtc_crypto_read_retry, priv, bio);
-	if (space == NULL)
-		return;
-
-	dmtc = (struct dmtc_helper *)space;
-	dmtc->free_addr = space;
-	space += sizeof(struct dmtc_helper);
-	dmtc->orig_buf = NULL;
-	dmtc->data_buf = bio->bio_buf->b_data;
-	dmtc->priv = priv;
-	bio->bio_caller_info2.ptr = dmtc;
-	bio->bio_buf->b_error = 0;
-
-	/*
-	 * Load crypto descriptors (crp/crd loop)
-	 */
-	bzero(space, sz);
-	ptr = space;
-	bio->bio_caller_info3.value = sectors;
-	cpu_sfence();
-#if 0
-	kprintf("Read, bytes = %d (b_bcount), "
-		"sectors = %d (bio = %p, b_cmd = %d)\n",
-		bytes, sectors, bio, bio->bio_buf->b_cmd);
-#endif
-	for (i = 0; i < sectors; i++) {
-		crp = (struct cryptop *)ptr;
-		ptr += sizeof(*crp);
-		crd = (struct cryptodesc *)ptr;
-		ptr += sizeof (*crd);
-
-		crp->crp_buf = dmtc->data_buf + i * DEV_BSIZE;
-
-		crp->crp_sid = priv->crypto_sid;
-		crp->crp_ilen = crp->crp_olen = DEV_BSIZE;
+	memcpy(data_buf, bio->bio_buf->b_data, bytes);
 
-		crp->crp_opaque = (void *)bio;
+	bio->bio_buf->b_error = dmtc_bio_encdec(priv, data_buf, bytes,
+	    bio->bio_offset, priv->crypto_cipher->decrypt);
 
-		crp->crp_callback = dmtc_crypto_cb_read_done;
-		crp->crp_desc = crd;
-		crp->crp_etype = 0;
-		crp->crp_flags = CRYPTO_F_CBIFSYNC | CRYPTO_F_REL |
-				 CRYPTO_F_BATCH;
+	if (bio->bio_buf->b_error) {
+		kprintf(
+		    "dm_target_crypt: dmtc_bio_read_decrypt error = %d\n",
+		    bio->bio_buf->b_error);
 
-		crd->crd_alg = priv->crypto_alg;
+		bio->bio_buf->b_flags |= B_ERROR;
+	} else {
+		memcpy(bio->bio_buf->b_data, data_buf, bytes);
+	}
 #if 0
-		crd->crd_key = (caddr_t)priv->crypto_key;
-		crd->crd_klen = priv->crypto_klen;
-#endif
-
-		crd->crd_skip = 0;
-		crd->crd_len = DEV_BSIZE /* XXX */;
-		crd->crd_flags = CRD_F_IV_EXPLICIT | CRD_F_IV_PRESENT;
-		crd->crd_next = NULL;
-
-		crd->crd_flags &= ~CRD_F_ENCRYPT;
-
-		KTR_LOG(dmcrypt_crypto_read_start, crp, bio->bio_buf, i,
-		    sectors);
-
-		/*
-		 * Note: last argument is used to generate salt(?) and is
-		 *	 a 64 bit value, but the original code passed an
-		 *	 int.  Changing it now will break pre-existing
-		 *	 crypt volumes.
-		 */
-		priv->ivgen->gen_iv(priv, crd->crd_iv, sizeof(crd->crd_iv),
-				    isector + i, crp);
+	else if (bio->bio_buf->b_flags & B_HASBOGUS) {
+		memcpy(bio->bio_buf->b_data, dmtc->data_buf,
+		       bio->bio_buf->b_bcount);
 	}
+#endif
+	struct bio *obio = pop_bio(bio);
+	biodone(obio);
 }
 
-/*
- * STRATEGY READ PATH PART 3/3
- */
-static int
-dmtc_crypto_cb_read_done(struct cryptop *crp)
+static void
+dmtc_bio_read_decrypt(dm_target_crypt_config_t *priv, struct bio *bio)
 {
-	struct dmtc_helper *dmtc;
-	struct bio *bio, *obio;
-	int n;
-
-	if (crp->crp_etype == EAGAIN)
-		return crypto_dispatch(crp);
-
-	bio = (struct bio *)crp->crp_opaque;
-	KKASSERT(bio != NULL);
-
-	/*
-	 * Cumulative error
-	 */
-	if (crp->crp_etype) {
-		kprintf("dm_target_crypt: dmtc_crypto_cb_read_done "
-			"crp_etype = %d\n",
-			crp->crp_etype);
-		bio->bio_buf->b_error = crp->crp_etype;
-	}
-
-	/*
-	 * On the last chunk of the decryption we do any required copybacks
-	 * and complete the I/O.
-	 */
-	n = atomic_fetchadd_int(&bio->bio_caller_info3.value, -1);
-#if 0
-	kprintf("dmtc_crypto_cb_read_done %p, n = %d\n", bio, n);
-#endif
-
-	KTR_LOG(dmcrypt_crypto_cb_read_done, crp, bio->bio_buf, n);
+	int error = workqueue_submit_job(
+	    &priv->crypto_read_workqueues[select_read_workqueue_index(
+		priv)],
+	    dmtc_bio_read_decrypt_job, (void *)priv, (void *)bio);
+	if (error) {
+		bio->bio_buf->b_error = error;
+		kprintf(
+		    "dm_target_crypt: dmtc_bio_read_decrypt error = %d\n",
+		    bio->bio_buf->b_error);
 
-	if (n == 1) {
-		/*
-		 * For the B_HASBOGUS case we didn't decrypt in place,
-		 * so we need to copy stuff back into the buf.
-		 *
-		 * (disabled for now).
-		 */
-		dmtc = bio->bio_caller_info2.ptr;
-		if (bio->bio_buf->b_error) {
-			bio->bio_buf->b_flags |= B_ERROR;
-		}
-#if 0
-		else if (bio->bio_buf->b_flags & B_HASBOGUS) {
-			memcpy(bio->bio_buf->b_data, dmtc->data_buf,
-			       bio->bio_buf->b_bcount);
-		}
-#endif
-		mpipe_free(&dmtc->priv->read_mpipe, dmtc->free_addr);
-		obio = pop_bio(bio);
+		bio->bio_buf->b_flags |= B_ERROR;
+		struct bio *obio = pop_bio(bio);
 		biodone(obio);
 	}
-	return 0;
 }
+
 /* END OF STRATEGY READ SECTION */
 
 /*
- * STRATEGY WRITE PATH PART 1/3
+ * STRATEGY WRITE PATH
  */
 
+__inline static void
+dmtc_bio_write_encrypt_job_do(dm_target_crypt_config_t *priv,
+    struct bio *bio, struct worker_context *ctx);
+
 static void
-dmtc_crypto_write_retry(void *arg1, void *arg2)
+dmtc_bio_write_encrypt_job(void *arg1, void *arg2, void *ctx)
 {
-	dm_target_crypt_config_t *priv = arg1;
-	struct bio *bio = arg2;
-
-	KTR_LOG(dmcrypt_crypto_write_retry, bio->bio_buf);
-
-	dmtc_crypto_write_start(priv, bio);
+	dmtc_bio_write_encrypt_job_do(arg1, arg2, ctx);
 }
 
-static void
-dmtc_crypto_write_start(dm_target_crypt_config_t *priv, struct bio *bio)
+__inline static void
+dmtc_bio_write_encrypt_job_do(dm_target_crypt_config_t *priv,
+    struct bio *bio, struct worker_context *ctx)
 {
-	struct dmtc_helper *dmtc;
-	struct cryptodesc *crd;
-	struct cryptop *crp;
-	int i, bytes, sectors, sz;
-	off_t isector;
-	u_char *ptr, *space;
-
-	/*
-	 * Use b_bcount for consistency
-	 */
-	bytes = bio->bio_buf->b_bcount;
-
-	isector = bio->bio_offset / DEV_BSIZE;	/* ivgen salt base? */
-	sectors = bytes / DEV_BSIZE;		/* Number of sectors */
-	sz = sectors * (sizeof(*crp) + sizeof(*crd));
-
-	/*
-	 * For writes and reads with bogus page don't decrypt in place.
-	 */
-	space = mpipe_alloc_callback(&priv->write_mpipe,
-				     dmtc_crypto_write_retry, priv, bio);
-	if (space == NULL)
-		return;
+	uint8_t *data_buf = ctx->data_buf;
 
-	dmtc = (struct dmtc_helper *)space;
-	dmtc->free_addr = space;
-	space += sizeof(struct dmtc_helper);
-	memcpy(space + sz, bio->bio_buf->b_data, bytes);
+	KKASSERT(ctx->data_buf_busy == false);
 
-	bio->bio_caller_info2.ptr = dmtc;
-	bio->bio_buf->b_error = 0;
-
-	dmtc->orig_buf = bio->bio_buf->b_data;
-	dmtc->data_buf = space + sz;
-	dmtc->priv = priv;
+	ctx->data_buf_busy = true;
 
 	/*
-	 * Load crypto descriptors (crp/crd loop)
+	 * Use b_bcount for consistency
 	 */
-	bzero(space, sz);
-	ptr = space;
-	bio->bio_caller_info3.value = sectors;
-	cpu_sfence();
-#if 0
-	kprintf("Write, bytes = %d (b_bcount), "
-		"sectors = %d (bio = %p, b_cmd = %d)\n",
-		bytes, sectors, bio, bio->bio_buf->b_cmd);
-#endif
-	for (i = 0; i < sectors; i++) {
-		crp = (struct cryptop *)ptr;
-		ptr += sizeof(*crp);
-		crd = (struct cryptodesc *)ptr;
-		ptr += sizeof (*crd);
+	int bytes = bio->bio_buf->b_bcount;
 
-		crp->crp_buf = dmtc->data_buf + i * DEV_BSIZE;
+	KKASSERT(bytes <= ctx->data_buf_size);
 
-		crp->crp_sid = priv->crypto_sid;
-		crp->crp_ilen = crp->crp_olen = DEV_BSIZE;
+	memcpy(data_buf, bio->bio_buf->b_data, bytes);
 
-		crp->crp_opaque = (void *)bio;
+	bio->bio_buf->b_error = dmtc_bio_encdec(priv, data_buf, bytes,
+	    bio->bio_offset, priv->crypto_cipher->encrypt);
 
-		crp->crp_callback = dmtc_crypto_cb_write_done;
-		crp->crp_desc = crd;
-		crp->crp_etype = 0;
-		crp->crp_flags = CRYPTO_F_CBIFSYNC | CRYPTO_F_REL |
-				 CRYPTO_F_BATCH;
+	if (bio->bio_buf->b_error) {
+		kprintf(
+		    "dm_target_crypt: dmtc_bio_write_encrypt error = %d\n",
+		    bio->bio_buf->b_error);
 
-		crd->crd_alg = priv->crypto_alg;
-#if 0
-		crd->crd_key = (caddr_t)priv->crypto_key;
-		crd->crd_klen = priv->crypto_klen;
-#endif
-
-		crd->crd_skip = 0;
-		crd->crd_len = DEV_BSIZE /* XXX */;
-		crd->crd_flags = CRD_F_IV_EXPLICIT | CRD_F_IV_PRESENT;
-		crd->crd_next = NULL;
-
-		crd->crd_flags |= CRD_F_ENCRYPT;
+		bio->bio_buf->b_flags |= B_ERROR;
+		struct bio *obio = pop_bio(bio);
+		biodone(obio);
+	} else {
+		bio->bio_caller_info2.ptr =
+		    bio->bio_buf->b_data; /* orig_buf */
+		bio->bio_caller_info3.ptr = ctx;
+		bio->bio_buf->b_data = data_buf;
+		bio->bio_done = dmtc_bio_write_done;
 
 		/*
-		 * Note: last argument is used to generate salt(?) and is
-		 *	 a 64 bit value, but the original code passed an
-		 *	 int.  Changing it now will break pre-existing
-		 *	 crypt volumes.
+		 * TODO: @dillon can't we just copy back data_buf to
+		 * bio->bio_buf->b_data and then call vn_stategy with
+		 * it, or do we have to call vn_strategy pointing to our
+		 * own local allocated memory?
 		 */
+		vn_strategy(priv->pdev->pdev_vnode, bio);
 
-		KTR_LOG(dmcrypt_crypto_write_start, crp, bio->bio_buf,
-		    i, sectors);
-
-		priv->ivgen->gen_iv(priv, crd->crd_iv, sizeof(crd->crd_iv),
-				    isector + i, crp);
+		while (ctx->data_buf_busy) {
+			tsleep(ctx, 0,
+			    "wait for dmtc_bio_write_done to complete",
+			    100);
+		}
 	}
 }
 
-/*
- * STRATEGY WRITE PATH PART 2/3
- */
-static int
-dmtc_crypto_cb_write_done(struct cryptop *crp)
+static void
+dmtc_bio_write_done(struct bio *bio)
 {
-	struct dmtc_helper *dmtc;
-	dm_target_crypt_config_t *priv;
-	struct bio *bio, *obio;
-	int n;
+	struct worker_context *ctx = bio->bio_caller_info3.ptr;
 
-	if (crp->crp_etype == EAGAIN)
-		return crypto_dispatch(crp);
+	ctx->data_buf_busy = false;
+	wakeup(ctx);
 
-	bio = (struct bio *)crp->crp_opaque;
-	KKASSERT(bio != NULL);
+	// Restore original bio buffer
+	bio->bio_buf->b_data = bio->bio_caller_info2.ptr;
 
-	/*
-	 * Cumulative error
-	 */
-	if (crp->crp_etype != 0) {
-		kprintf("dm_target_crypt: dmtc_crypto_cb_write_done "
-			"crp_etype = %d\n",
-		crp->crp_etype);
-		bio->bio_buf->b_error = crp->crp_etype;
-	}
-
-	/*
-	 * On the last chunk of the encryption we issue the write
-	 */
-	n = atomic_fetchadd_int(&bio->bio_caller_info3.value, -1);
-#if 0
-	kprintf("dmtc_crypto_cb_write_done %p, n = %d\n", bio, n);
-#endif
-
-	KTR_LOG(dmcrypt_crypto_cb_write_done, crp, bio->bio_buf, n);
+	struct bio *obio = pop_bio(bio);
+	biodone(obio);
+}
 
-	if (n == 1) {
-		dmtc = bio->bio_caller_info2.ptr;
-		priv = (dm_target_crypt_config_t *)bio->bio_caller_info1.ptr;
+static void
+dmtc_bio_write_encrypt(dm_target_crypt_config_t *priv, struct bio *bio)
+{
+	int error = workqueue_submit_job(
+	    &priv->crypto_write_workqueues[select_write_workqueue_index(
+		priv)],
+	    dmtc_bio_write_encrypt_job, (void *)priv, (void *)bio);
+	if (error) {
+		bio->bio_buf->b_error = error;
+		kprintf(
+		    "dm_target_crypt: dmtc_bio_write_encrypt error = %d\n",
+		    bio->bio_buf->b_error);
 
-		if (bio->bio_buf->b_error) {
-			bio->bio_buf->b_flags |= B_ERROR;
-			mpipe_free(&dmtc->priv->write_mpipe, dmtc->free_addr);
-			obio = pop_bio(bio);
-			biodone(obio);
-		} else {
-			dmtc->orig_buf = bio->bio_buf->b_data;
-			bio->bio_buf->b_data = dmtc->data_buf;
-			bio->bio_done = dmtc_bio_write_done;
-			vn_strategy(priv->pdev->pdev_vnode, bio);
-		}
+		bio->bio_buf->b_flags |= B_ERROR;
+		struct bio *obio = pop_bio(bio);
+		biodone(obio);
 	}
-	return 0;
 }
 
-/*
- * STRATEGY WRITE PATH PART 3/3
- */
-static void
-dmtc_bio_write_done(struct bio *bio)
+/* END OF STRATEGY WRITE SECTION */
+
+static int
+dmtc_bio_encdec(dm_target_crypt_config_t *priv, uint8_t *data_buf,
+    int bytes, off_t offset, crypto_cipher_blockfn_t blockfn)
 {
-	struct dmtc_helper *dmtc;
-	struct bio *obio;
+	struct crypto_cipher_iv iv;
+	int sectors = bytes / DEV_BSIZE;    /* Number of sectors */
+	off_t isector = offset / DEV_BSIZE; /* ivgen salt base? */
+	int error = 0;
 
-	dmtc = bio->bio_caller_info2.ptr;
-	bio->bio_buf->b_data = dmtc->orig_buf;
-	mpipe_free(&dmtc->priv->write_mpipe, dmtc->free_addr);
+	KKASSERT((sectors * DEV_BSIZE) == bytes);
 
-	KTR_LOG(dmcrypt_bio_write_done, bio->bio_buf);
+	for (int i = 0; i < sectors; i++) {
+		/*
+		 * Note: last argument is used to generate salt(?) and
+		 * is a 64 bit value, but the original code passed an
+		 *	 int.  Changing it now will break pre-existing
+		 *	 crypt volumes.
+		 */
+		priv->ivgen->gen_iv(priv, (uint8_t *)&iv, sizeof(iv),
+		    isector + i);
 
-	obio = pop_bio(bio);
-	biodone(obio);
-}
-/* END OF STRATEGY WRITE SECTION */
+		error = blockfn(&priv->crypto_context,
+		    data_buf + i * DEV_BSIZE, DEV_BSIZE, &iv);
 
+		if (error) {
+			break;
+		}
+	}
 
+	// TODO: required?
+	explicit_bzero(&iv, sizeof(iv));
+
+	return (error);
+}
 
 /* DUMPING MAGIC */
 
@@ -1309,7 +1171,6 @@ dm_target_crypt_dump(dm_table_entry_t *table_en, void *data, size_t length, off_
 {
 	static struct dmtc_dump_helper dump_helper;
 	dm_target_crypt_config_t *priv;
-	int id;
 	static int first_call = 1;
 
 	priv = table_en->target_config;
@@ -1321,7 +1182,6 @@ dm_target_crypt_dump(dm_table_entry_t *table_en, void *data, size_t length, off_
 
 	/* Magically enable tsleep */
 	tsleep_crypto_dump = 1;
-	id = 0;
 
 	/*
 	 * 0 length means flush buffers and return
@@ -1343,18 +1203,7 @@ dm_target_crypt_dump(dm_table_entry_t *table_en, void *data, size_t length, off_
 	dump_helper.length = length;
 	dump_helper.offset = offset +
 	    priv->block_offset * DEV_BSIZE;
-	dump_helper.ident = &id;
-	dmtc_crypto_dump_start(priv, &dump_helper);
-
-	/*
-	 * Hackery to make stuff appear synchronous. The crypto callback will
-	 * set id to 1 and call wakeup on it. If the request completed
-	 * synchronously, id will be 1 and we won't bother to sleep. If not,
-	 * the crypto request will complete asynchronously and we sleep until
-	 * it's done.
-	 */
-	if (id == 0)
-		tsleep(&dump_helper, 0, "cryptdump", 0);
+	dmtc_crypto_dump(priv, &dump_helper);
 
 	dump_helper.offset = dm_pdev_correct_dump_offset(priv->pdev,
 	    dump_helper.offset);
@@ -1368,95 +1217,20 @@ dm_target_crypt_dump(dm_table_entry_t *table_en, void *data, size_t length, off_
 }
 
 static void
-dmtc_crypto_dump_start(dm_target_crypt_config_t *priv, struct dmtc_dump_helper *dump_helper)
+dmtc_crypto_dump(dm_target_crypt_config_t *priv, struct dmtc_dump_helper *dump_helper)
 {
-	struct cryptodesc *crd;
-	struct cryptop *crp;
-	int i, bytes, sectors;
-	off_t isector;
-
-	bytes = dump_helper->length;
+	int bytes = dump_helper->length;
 
-	isector = dump_helper->offset / DEV_BSIZE;	/* ivgen salt base? */
-	sectors = bytes / DEV_BSIZE;		/* Number of sectors */
-	dump_helper->sectors = sectors;
-#if 0
-	kprintf("Dump, bytes = %d, "
-		"sectors = %d, LENGTH=%zu\n", bytes, sectors, dump_helper->length);
-#endif
 	KKASSERT(dump_helper->length <= 65536);
 
 	memcpy(dump_helper->space, dump_helper->data, bytes);
 
-	cpu_sfence();
-
-	for (i = 0; i < sectors; i++) {
-		crp = &dump_helper->crp[i];
-		crd = &dump_helper->crd[i];
-
-		crp->crp_buf = dump_helper->space + i * DEV_BSIZE;
-
-		crp->crp_sid = priv->crypto_sid;
-		crp->crp_ilen = crp->crp_olen = DEV_BSIZE;
-
-		crp->crp_opaque = (void *)dump_helper;
-
-		crp->crp_callback = dmtc_crypto_cb_dump_done;
-		crp->crp_desc = crd;
-		crp->crp_etype = 0;
-		crp->crp_flags = CRYPTO_F_CBIFSYNC | CRYPTO_F_REL |
-				 CRYPTO_F_BATCH;
-
-		crd->crd_alg = priv->crypto_alg;
-
-		crd->crd_skip = 0;
-		crd->crd_len = DEV_BSIZE /* XXX */;
-		crd->crd_flags = CRD_F_IV_EXPLICIT | CRD_F_IV_PRESENT;
-		crd->crd_next = NULL;
-
-		crd->crd_flags |= CRD_F_ENCRYPT;
-
-		/*
-		 * Note: last argument is used to generate salt(?) and is
-		 *	 a 64 bit value, but the original code passed an
-		 *	 int.  Changing it now will break pre-existing
-		 *	 crypt volumes.
-		 */
-		priv->ivgen->gen_iv(priv, crd->crd_iv, sizeof(crd->crd_iv),
-				    isector + i, crp);
-	}
-}
-
-static int
-dmtc_crypto_cb_dump_done(struct cryptop *crp)
-{
-	struct dmtc_dump_helper *dump_helper;
-	int n;
-
-	if (crp->crp_etype == EAGAIN)
-		return crypto_dispatch(crp);
-
-	dump_helper = (struct dmtc_dump_helper *)crp->crp_opaque;
-	KKASSERT(dump_helper != NULL);
-
-	if (crp->crp_etype != 0) {
-		kprintf("dm_target_crypt: dmtc_crypto_cb_dump_done "
-			"crp_etype = %d\n",
-		crp->crp_etype);
-		return crp->crp_etype;
+	int error = dmtc_bio_encdec(priv, dump_helper->space, bytes, dump_helper->offset,
+			priv->crypto_cipher->encrypt);
+	if (error != 0) {
+		kprintf("dm_target_crypt: dmtc_crypto_dump = %d\n",
+		error);
 	}
-
-	/*
-	 * On the last chunk of the encryption we return control
-	 */
-	n = atomic_fetchadd_int(&dump_helper->sectors, -1);
-
-	if (n == 1) {
-		atomic_add_int(dump_helper->ident, 1);
-		wakeup(dump_helper);
-	}
-
-	return 0;
 }
 
 static int
@@ -1498,3 +1272,4 @@ dmtc_mod_handler(module_t mod, int type, void *unused)
 }
 
 DM_TARGET_MODULE(dm_target_crypt, dmtc_mod_handler);
+MODULE_DEPEND(dm_target_crypt, crypto, 2, 2, 2);
diff --git a/sys/dev/raid/arcmsr/arcmsr.h b/sys/dev/raid/arcmsr/arcmsr.h
index 5140e6b7e3..f6cd595f86 100644
--- a/sys/dev/raid/arcmsr/arcmsr.h
+++ b/sys/dev/raid/arcmsr/arcmsr.h
@@ -35,6 +35,7 @@
 * $FreeBSD: head/sys/dev/arcmsr/arcmsr.h 259565 2013-12-18 19:25:40Z delphij $
 */
 #include <sys/ioccom.h>
+#include <sys/bus.h>
 #define ARCMSR_SCSI_INITIATOR_ID	255
 #define ARCMSR_DEV_SECTOR_SIZE		512
 #define ARCMSR_MAX_XFER_SECTORS		4096
diff --git a/sys/platform/pc64/conf/files b/sys/platform/pc64/conf/files
index 46c9fb9715..add86e3a73 100644
--- a/sys/platform/pc64/conf/files
+++ b/sys/platform/pc64/conf/files
@@ -35,7 +35,6 @@ hptrr_lib.bo			optional	hptrr			\
 	clean 		"hptrr_lib.bo"
 
 # XXX use assembler versions of bf_enc
-crypto/blowfish/bf_enc.c		optional	crypto
 crypto/des/des_enc.c			optional	crypto
 crypto/des/des_ecb.c			optional	crypto
 crypto/des/des_setkey.c			optional	crypto
@@ -62,15 +61,9 @@ ${OSACPI_MD_DIR}/acpi_wakeup.c		optional        acpi
 #	no-obj no-implicit-rule	before-depend				\
 #	clean		"acpi_wakecode.h"
 #
-dev/crypto/aesni/aesencdec_x86_64.S	optional	aesni
-dev/crypto/aesni/aeskeys_x86_64.S	optional	aesni
-dev/crypto/aesni/aesni.c		optional	aesni
-dev/crypto/aesni/aesni_wrap.c		optional	aesni
-dev/crypto/padlock/padlock.c		optional	padlock
-dev/crypto/padlock/padlock_cipher.c	optional	padlock
-dev/crypto/padlock/padlock_hash.c	optional	padlock
-dev/crypto/padlock/padlock_rng.c	optional	padlock
-dev/crypto/padlock/rng_harvest_x86_64.S	optional	padlock
+crypto/aesni/aesencdec_x86_64.S	optional	aesni
+crypto/aesni/aeskeys_x86_64.S	optional	aesni
+crypto/aesni/aesni.c		optional	aesni
 dev/crypto/rdrand/rdrand.c		optional	rdrand
 dev/crypto/rdrand/rdrand_harvest_x86_64.S	optional	rdrand
 dev/video/fb/fb.c			optional	vga
diff --git a/sys/platform/vkernel64/conf/files b/sys/platform/vkernel64/conf/files
index 1ff7e6aa94..feb7675aa7 100644
--- a/sys/platform/vkernel64/conf/files
+++ b/sys/platform/vkernel64/conf/files
@@ -1,7 +1,6 @@
 # This file tells config what files go into building a kernel,
 # files marked standard are always included.
 #
-crypto/blowfish/bf_enc.c		optional	crypto
 crypto/des/des_enc.c			optional	crypto
 crypto/des/des_ecb.c			optional	crypto
 crypto/des/des_setkey.c			optional	crypto
